(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["DragResize"] = factory();
	else
		root["DragResize"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "nUpp");
/******/ })
/************************************************************************/
/******/ ({

/***/ "nUpp":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
throw new Error("Cannot find module \"draggable-move\"");
/**
 * Created by PC on 2017/11/23.
 */



var ElZoom = function (options) {
    if (!options.selector) throw new Error("drag selector id is required ! ");
    this.el = typeof options.selector === 'string' ? document.getElementById(options.selector) : options.selector;
    if (typeof this.el !== 'object' || this.el.nodeType !== 1) throw Error("drag selector el is not a node element !");
    this.wrapper = document.documentElement || document.body;
    if (options.wrapper) {
        this.wrapper = typeof options.wrapper === 'string' ? getElementById(options.wrapper) : options.wrapper;
    }
    if (typeof this.wrapper !== 'object' || this.wrapper.nodeType !== 1) throw Error("move wrapper el is not a node element !");
    this.min = {
        width: this.el.clientWidth,
        height: this.el.clientHeight
    };
    if (options.min && options.min.width && options.min.height) {
        this.min = options.min
    }
    this.init(options);
};

ElZoom.prototype = {
    init: function (options) {
        var _this = this;
        this.el.className += ' resize-box';
        this.resizeCallBack = typeof options.resize === 'function' ? options.resize : ()=> {
            console.log("drag resize ... ", this);
        };
        this.move = typeof options.move === 'function' ? options.move : ()=> {
            console.log("drag moving ... ", this);
        };

        this.dragObj = new __WEBPACK_IMPORTED_MODULE_0_draggable_move___default.a({
            el: this.el,
            wrapper: this.wrapper,
            move: function (pos, drag) {
                const el = drag.scope;
                let _left = el.offsetLeft + pos.moveX;
                let _top = el.offsetTop + pos.moveY;
                _top = Math.min(drag.moveArea.y, Math.max(0, _top));
                _left = Math.min(drag.moveArea.x, Math.max(0, _left));
                el.style.left = _left + 'px';
                el.style.top = _top + 'px';
                _this.move.apply(null, [_this.dragObj]);
            }
        });

        this.createReact();
    },
    createReact: function () {
        var _this = this;
        var rect = ['resize-T', 'resize-R', 'resize-B', 'resize-L', 'resize-TL', 'resize-TR', 'resize-BR', 'resize-BL'];
        var rectLen = rect.length;
        for (var i = 0; i < rectLen; i++) {
            var tempEl = document.createElement('div');
            tempEl.className = rect[i];
            this.el.appendChild(tempEl);
            new __WEBPACK_IMPORTED_MODULE_0_draggable_move___default.a({
                selector: tempEl,
                wrapper: this.wrapper,
                move: function (pos, drag) {
                    _this.resize(drag.el.className, pos, drag);
                }
            });
        }
    },
    resize: function (dir, pos, drag) {
        var _this = this;
        var getPrototypeVal = function (val) {
            return (val + '').replace("px", '') * 1;
        };
        var setScopeSize = function (pro, val, changePro) {
            var proMap = {
                'width': 'clientWidth',
                'height': 'clientHeight',
                'top': 'offsetTop',
                'left': 'offsetLeft'
            };
            if (changePro) {
                var oldChangePro = getPrototypeVal(_this.el[proMap[changePro]]);
                _this.el.style[changePro] = oldChangePro - val + 'px';
            }
            _this.el.style[pro] = Math.max(_this.min[pro], _this.el[proMap[pro]] + val) + 'px';
            _this.resizeCallBack.apply(null, [_this]);
        };
        var resizeBoxSize = {
            width: this.el.clientWidth,
            height: this.el.clientHeight
        };
        var resizeBoxPos = {
            top: this.el.offsetTop,
            left: this.el.offsetLeft
        };
        var wrapperBoxSize = {
            width: this.wrapper.offsetWidth,
            height: this.wrapper.offsetHeight
        };
        var resizeBoxMaxReduceSize = {
            width: this.min.width - resizeBoxSize.width,
            height: this.min.height - resizeBoxSize.height
        };
        var getSettingResize = function (val, max, min) {
            return Math.max(Math.min(val, max), min);
        };
        switch (dir) {
            case "resize-T":
                setScopeSize('height', getSettingResize(-pos.moveY, resizeBoxPos.top, resizeBoxMaxReduceSize.height), 'top');
                break;
            case "resize-L":
                setScopeSize('width', getSettingResize(-pos.moveX, resizeBoxPos.left, resizeBoxMaxReduceSize.width), 'left');
                break;
            case "resize-R":
                setScopeSize('width', getSettingResize(pos.moveX, wrapperBoxSize.width - resizeBoxPos.left - resizeBoxSize.width, resizeBoxMaxReduceSize.width));
                break;
            case "resize-B":
                setScopeSize('height', getSettingResize(pos.moveY, wrapperBoxSize.height - resizeBoxPos.top - resizeBoxSize.height, resizeBoxMaxReduceSize.height));
                break;
            case "resize-TL":
                setScopeSize('width', getSettingResize(-pos.moveX, resizeBoxPos.left, resizeBoxMaxReduceSize.width), 'left');
                setScopeSize('height', getSettingResize(-pos.moveY, resizeBoxPos.top, resizeBoxMaxReduceSize.height), 'top');
                break;
            case "resize-TR":
                setScopeSize('width', getSettingResize(pos.moveX, wrapperBoxSize.width - resizeBoxPos.left - resizeBoxSize.width, resizeBoxMaxReduceSize.width));
                setScopeSize('height', getSettingResize(-pos.moveY, resizeBoxPos.top, resizeBoxMaxReduceSize.height), 'top');
                break;
            case "resize-BR":
                setScopeSize('width', getSettingResize(pos.moveX, wrapperBoxSize.width - resizeBoxPos.left - resizeBoxSize.width, resizeBoxMaxReduceSize.width));
                setScopeSize('height', getSettingResize(pos.moveY, wrapperBoxSize.height - resizeBoxPos.top - resizeBoxSize.height, resizeBoxMaxReduceSize.height));
                break;
            case "resize-BL":
                setScopeSize('width', getSettingResize(-pos.moveX, resizeBoxPos.left, resizeBoxMaxReduceSize.width), 'left');
                setScopeSize('height', getSettingResize(pos.moveY, wrapperBoxSize.height - resizeBoxSize.height - resizeBoxPos.top, resizeBoxMaxReduceSize.height));
                break;
        }
    }
};

/* harmony default export */ __webpack_exports__["default"] = (ElZoom);


/***/ })

/******/ });
});